using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using XYY.Core.Standard.Data.Infrastructure;
using XYY.Service.Standard.Order;
using XYY.Service.Standard.RegionService;
namespace XYY.gRpc.Order
{
    public class Startup
    {
        public IConfiguration Configuration { get; }

        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }
        // This method gets called by the runtime. Use this method to add services to the container.
        // For more information on how to configure your application, visit https://go.microsoft.com/fwlink/?LinkID=398940
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddGrpc();
            services.AddGrpcReflection();
            services.AddDistributedMemoryCache();
            string connection = Configuration["DBConnectionStrings:SqlService"];
            //Console.WriteLine("数据服务注册" + connection);
            services.AddTransient<IUnitOfWork>(x => new UnitOfWork(ConnectionHelper.BuildDbConnection(connection), connection));
            services.AddAliyunService(Configuration);
            services.AddTransient<IMoreThanOneTicketService, InputMoreThanOneTicketService>();
            services.AddTransient<IOrderNumberService, GetOrderNumbserService>();
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IWebHostEnvironment env)
        {
            if (env.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }

            app.UseRouting();

            app.UseEndpoints(endpoints =>
            {
                endpoints.MapGrpcService<ZipCodePushService>();
                endpoints.MapGrpcService<MoreThanOneTicketOrderService>();
                endpoints.MapGet("/", async context =>
                {
                    await context.Response.WriteAsync("Communication with gRPC endpoints must be made through a gRPC client. To learn how to create a client, visit: https://go.microsoft.com/fwlink/?linkid=2086909");
                });
                endpoints.MapGrpcReflectionService();
            });
        }
    }
}
